import { HttpClient } from "@angular/common/http";
import { Component, OnInit, Input } from "@angular/core";
import { FormBuilder, FormGroup, Validators } from "@angular/forms";
import { NzMessageService } from "ng-zorro-antd/message";
import { NzModalRef, NzModalService } from "ng-zorro-antd/modal";
@Component({
  selector: "app-get-out-of-line-details",
  templateUrl: "./get-out-of-line-details.component.html",
  styleUrls: ["./get-out-of-line-details.component.scss"],
})
export class GetOutOfLineDetailsComponent implements OnInit {
  @Input() data: any;
  @Input() isBtn: any;
  constructor(
    private http: HttpClient,
    private message: NzMessageService,
    private modal: NzModalService,
    private initialModal: NzModalRef
  ) {}

  imgUrl: string;
  vedioUrl: string;
  content;
  details;

  isAnxin = false;
  coordinate = []; //完整坐标点信息
  currentCoordinate = []; //当前需要标绘坐标点信息
  legendList: any = [];
  typeArr = [
    { id: 0, name: "工装", color: "#91CCFF" },
    { id: 1, name: "便装", color: "#46DFFF" },
    { id: 2, name: "抽烟", color: "#36A2FF" },
    { id: 3, name: "打电话", color: "#FF6181" },
    { id: 4, name: "隔离锥", color: "#000000" },
    { id: 5, name: "手持灭火器", color: "#ffffff" },
    { id: 6, name: "推车灭火器", color: "#B4C3FF" },
    { id: 7, name: "静电接地", color: "#FF9963" },
    { id: 8, name: "输油管(连接)", color: "#5A9CFF" },
    { id: 9, name: "输油管连接车", color: "#4BFFD4" },
    { id: 10, name: "输油管连接卸油口", color: "red" },
    { id: 11, name: "卸油口盖子", color: "green" },
    { id: 12, name: "卸油车", color: "yellow" },
    { id: 13, name: "私家车", color: "black" },
    { id: 14, name: "断开的卸油管", color: "blue" },
    { id: 15, name: "烟雾预警", color: "#B4C3FF" },
    { id: 16, name: "火灾报警", color: "red" },
    { id: 17, name: "延长工装", color: "blue" },
    { id: 18, name: "江苏工装", color: "blue" },
    { id: 19, name: "经理工装", color: "yellow" },
    { id: 20, name: "江苏道达尔工装", color: "yellow" },
    { id: 21, name: "延长壳牌工装", color: "red" },
    { id: 22, name: "山西高速工装", color: "red" },
  ];

  userName;

  isCarStop = false;

  pageIndex = 0;

  checkedAll = true;
  ngOnInit(): void {
    this.userName = JSON.parse(sessionStorage.getItem("userdata")).userName;
    console.log("预警数据", this.data);
    //进出口停车判断
    if (this.data.violation.eventSystemName == "进出口停车") {
      this.isCarStop = true;
    }
    //是否是安信产生的预警进行判断
    if (this.data.violatedItemSnapshot) {
      this.isAnxin = true;
    }

    //生成安信产生预警上面checkbox列表
    let dataArr = [];
    for (const key in JSON.parse(this.data.violatedItemSnapshot)) {
      const element = JSON.parse(this.data.violatedItemSnapshot)[key];
      dataArr.push(element);
    }
    this.coordinate = dataArr;
    this.currentCoordinate = JSON.parse(JSON.stringify(this.coordinate));
    let checkboxArr = [];
    this.coordinate.forEach((element) => {
      checkboxArr.push({ id: element.id, checked: true });
    });
    for (let i = 0; i < checkboxArr.length; i++) {
      if (!this.legendList.some((e) => e.id == checkboxArr[i].id))
        this.legendList.push(checkboxArr[i]);
    }

    this.details = this.data.content1;

    if (this.isCarStop && this.isAnxin) {
      if (!this.data.violateImage2) {
        this.data.violateImage2 = this.data.violateImage;
      }
      this.imgUrl = this.data.violateImage2;
    } else {
      this.imgUrl = this.data.violateImage;
    }

    this.vedioUrl = this.data.violateVideo;
    this.content = this.data.handleRecord;

    setTimeout(() => {
      if (this.isAnxin == true) {
        this.canvasLabel();
      }
    }, 0);
  }
  //进出口停车图片翻页
  pageturning(type) {
    if (type == "last") {
      if (this.pageIndex === 0) {
        this.message.create("info", "已到第一张图片");
      } else {
        this.pageIndex--;
        this.clearCanvas(this.data.violateImage2);
      }
    }
    if (type == "next") {
      if (this.pageIndex === 1) {
        this.message.create("info", "图片已经到底了");
      } else {
        this.pageIndex++;
        this.clearCanvas(this.data.violateImage);
      }
    }
  }

  //清空画布并且重新标绘
  clearCanvas(url) {
    this.ctx.clearRect(0, 0, this.canvasWidth, this.canvasHeight);
    let imgBg: any = document.getElementById("img" + this.data.id);
    imgBg.src = url;
    imgBg.onload = () => {
      window.setTimeout(() => {
        this.ctx.drawImage(imgBg, 0, 0, this.canvasWidth, this.canvasHeight);
        this.strokeRect(this.currentCoordinate);
      }, 0);
    };
  }
  canvasWidth = 0;
  canvasHeight = 0;
  ctx;
  canvasLabel() {
    let imgBg: any = document.getElementById("img" + this.data.id);
    imgBg.onload = () => {
      console.log("图片加载完毕...");
      this.canvasWidth = imgBg.offsetWidth;
      this.canvasHeight = imgBg.offsetHeight;
      const canvas: any = document.getElementById("canvas" + this.data.id);
      this.ctx = canvas.getContext("2d");
      const cWidth = canvas.width,
        cHeight = canvas.height;
      setTimeout(() => {
        console.log("以图画底,描绘预警框...");
        // 以图画底
        this.ctx.drawImage(imgBg, 0, 0, cWidth, cHeight);
        this.strokeRect(this.currentCoordinate);
      }, 100);
    };
  }

  strokeRect(data) {
    data.forEach((item) => {
      let startPoint = [
        Math.round(this.canvasWidth * item.box[0]),
        Math.round(this.canvasHeight * item.box[1]),
      ];
      let endPoint = [
        Math.round(this.canvasWidth * item.box[2]),
        Math.round(this.canvasHeight * item.box[3]),
      ];
      // console.log(startPoint, endPoint);
      this.ctx.strokeStyle = this.typeArr[item.id]?.color || "yellow";
      this.ctx.lineWidth = 3;
      this.ctx.strokeRect(
        startPoint[0],
        startPoint[1],
        endPoint[0] - startPoint[0],
        endPoint[1] - startPoint[1]
      );
      //如果当前矩形区域为错误区域，则左上角增加色块
      if (item.error) {
        this.ctx.fillStyle = this.typeArr[item.id]?.color || "yellow";
        this.ctx.fillRect(startPoint[0], startPoint[1], 10, 10);
      }
      this.ctx.fillStyle = this.typeArr[item.id]?.color || "yellow";
      this.ctx.font = "16px Verdana";
      let name = "";
      if (
        this.userName === "zhairjVerifier" ||
        this.userName === "admin" ||
        this.userName === "superadmin"
      ) {
        name = this.typeArr[item.id]?.name || "未定义" + item.scores;
      } else {
        name = this.typeArr[item.id]?.name || "未定义";
      }
      this.ctx.fillText(
        name,
        startPoint[0],
        startPoint[1] < 20 || item.id === 2 || item.id === 3
          ? endPoint[1] + 18
          : startPoint[1] - 5
      );
    });
  }

  typeChange(item) {
    if (item.checked) {
      this.coordinate.forEach((element) => {
        if (element.id === item.id) {
          this.currentCoordinate.push(element);
        }
      });
    } else {
      this.currentCoordinate = this.currentCoordinate.filter(
        (v) => v.id !== item.id
      );
    }

    this.ctx.clearRect(0, 0, this.canvasWidth, this.canvasHeight);
    let imgBg: any = document.getElementById("img" + this.data.id);
    const canvas: any = document.getElementById("canvas" + this.data.id);
    this.ctx.drawImage(imgBg, 0, 0, canvas.width, canvas.height);
    this.strokeRect(this.currentCoordinate);
  }
  typeChangeAll() {
    if (this.checkedAll) {
      this.legendList.forEach((element) => {
        element.checked = true;
      });
      this.currentCoordinate = this.coordinate;
    } else {
      this.legendList.forEach((element) => {
        element.checked = false;
      });
      this.currentCoordinate = [];
    }

    this.ctx.clearRect(0, 0, this.canvasWidth, this.canvasHeight);
    let imgBg: any = document.getElementById("img" + this.data.id);
    const canvas: any = document.getElementById("canvas" + this.data.id);
    this.ctx.drawImage(imgBg, 0, 0, canvas.width, canvas.height);
    this.strokeRect(this.currentCoordinate);
  }

  downImg() {
    const canvasDom: any = document.getElementById("canvas" + this.data.id);
    const imageData = canvasDom.toDataURL("image/png"); //返回base64的URL
    const elink = document.createElement("a");
    elink.download = "图片";
    elink.style.display = "none";
    elink.href = imageData;
    document.body.appendChild(elink);
    elink.click();
    URL.revokeObjectURL(elink.href); //释放URL对象
    document.body.removeChild(elink);
  }
  selectedType: string = "img";
  contentType(type) {
    this.selectedType = type;
  }
  isPushLoading = false;
  isMisinformationLoading = false;
  //推送
  push() {
    this.modal.confirm({
      nzTitle: "确定推送该预警吗?",
      nzOkText: "确定",
      nzOkType: "primary",
      nzOnOk: () => {
        this.isPushLoading = true;
        let body = {
          id: this.data.id,
          positive: true,
        };
        this.http
          .post(
            "/api/services/app/ViolateRecordVerification/VerifyViolateRecord",
            body
          )
          .subscribe(
            (data) => {
              this.message.create("success", "处置成功！");
              this.isPushLoading = false;
              this.initialModal.triggerOk();
            },
            (err) => {
              this.message.create("error", "处置失败！请联系管理员");
              this.isPushLoading = false;
            }
          );
      },
      nzCancelText: "取消",
      nzOnCancel: () => console.log("Cancel"),
    });
  }
  //误报
  misinformation() {
    this.modal.confirm({
      nzTitle: "判定该预警为误报吗?",
      nzOkText: "确定",
      nzOkType: "danger",
      nzOnOk: () => {
        this.isMisinformationLoading = true;
        let body = {
          id: this.data.id,
          positive: false,
        };
        this.http
          .post(
            "/api/services/app/ViolateRecordVerification/VerifyViolateRecord",
            body
          )
          .subscribe(
            (data) => {
              this.message.create("success", "处置成功！");
              this.isMisinformationLoading = false;
              this.initialModal.triggerOk();
            },
            (err) => {
              this.isMisinformationLoading = false;
              this.message.create("error", "处置失败！请联系管理员");
            }
          );
      },
      nzCancelText: "取消",
      nzOnCancel: () => console.log("Cancel"),
    });
  }
  isSrcError = false;
  imgErr() {
    this.isSrcError = true;
  }
}
