import { Routes, RouterModule } from "@angular/router";
import { NgModule } from "@angular/core";
import { AuthGuard } from "../auth.guard";
import { CriminalRecordsAdminComponent } from "./criminal-records-admin/criminal-records-admin.component";
import { OilUnloadingProcessListComponent } from "./oil-unloading-process-list/oil-unloading-process-list.component";
import { HistoriesComponent } from "./histories/histories.component";
import { StatisticsComponent } from "./statistics/statistics.component";
import { BgStationComponent } from "./statistics/bg-station/bg-station.component";
import { BgViolationComponent } from "./statistics/bg-violation/bg-violation.component";

const routes: Routes = [
  { path: "records", component: CriminalRecordsAdminComponent },
  { path: "histories", component: HistoriesComponent },
  // { path: 'records/oliunloadinglist', component: OilUnloadingProcessListComponent },
  // { path: 'records/petrolStation/oliunloadinglist', component: OilUnloadingProcessListComponent },
  {
    path: "statistics",
    component: StatisticsComponent,
    children: [
      { path: '', redirectTo: 'bgStation', pathMatch: 'full' },
      {
        path: "bgStation",
        component: BgStationComponent,
      },
      {
        path: "bgViolation",
        component: BgViolationComponent,
      },
    ],
  },
];

@NgModule({
  imports: [RouterModule.forChild(routes)],
  exports: [RouterModule],
})
export class PagesRoutingModule {}
