import { NgModule, CUSTOM_ELEMENTS_SCHEMA } from "@angular/core";
import { CommonModule } from "@angular/common";
import { A11yModule } from "@angular/cdk/a11y";
import { DragDropModule } from "@angular/cdk/drag-drop";
import { PortalModule } from "@angular/cdk/portal";
import { ScrollingModule } from "@angular/cdk/scrolling";
import { CdkStepperModule } from "@angular/cdk/stepper";
import { CdkTableModule } from "@angular/cdk/table";
import { CdkTreeModule } from "@angular/cdk/tree";
import { FormsModule, ReactiveFormsModule } from "@angular/forms";
import { RouterModule } from "@angular/router";
import { LoginComponent } from "./login/login.component";
import { HomeComponent } from "./home/home.component";
import { NzFormModule } from "ng-zorro-antd/form";
import { NzInputModule } from "ng-zorro-antd/input";
import { UiModule } from "../ui/ui.module";
import { NzButtonModule } from "ng-zorro-antd/button";
import { PagesRoutingModule } from "./pages-routing.module";
import { NzSelectModule } from "ng-zorro-antd/select";
import { NzDatePickerModule } from "ng-zorro-antd/date-picker";
import { NzIconModule } from "ng-zorro-antd/icon";
import { NzGridModule } from "ng-zorro-antd/grid";
import { NzModalModule } from "ng-zorro-antd/modal";
import { NzPaginationModule } from "ng-zorro-antd/pagination";
import { NzDropDownModule } from "ng-zorro-antd/dropdown";
import { NzMessageModule } from "ng-zorro-antd/message";
import { NzSpinModule } from "ng-zorro-antd/spin";
import { NzTreeModule } from "ng-zorro-antd/tree";
import { NzCollapseModule } from "ng-zorro-antd/collapse";
import { NzStepsModule } from "ng-zorro-antd/steps";
import { NzTableModule } from "ng-zorro-antd/table";
import { NzCheckboxModule } from "ng-zorro-antd/checkbox";
import { NzTimePickerModule } from "ng-zorro-antd/time-picker";
import { NzProgressModule } from "ng-zorro-antd/progress";
import { NzPopconfirmModule } from "ng-zorro-antd/popconfirm";
import { NzBadgeModule } from "ng-zorro-antd/badge";
import { NzRadioModule } from "ng-zorro-antd/radio";
import { CriminalRecordsAdminComponent } from "./criminal-records-admin/criminal-records-admin.component";
import { NzTreeSelectModule } from "ng-zorro-antd/tree-select";
import { GetOutOfLineDetailsComponent } from "./get-out-of-line-details/get-out-of-line-details.component";
import { NzNotificationModule } from "ng-zorro-antd/notification";
import { OilUnloadingProcessComponent } from "./oil-unloading-process/oil-unloading-process.component";
import { OilUnloadingProcessListComponent } from "./oil-unloading-process-list/oil-unloading-process-list.component";
import { ChangePasswordComponent } from "./change-password/change-password.component";
import { DisposeequipmentComponent } from "./disposeequipment/disposeequipment.component";
import { HistoriesComponent } from "./histories/histories.component";
import { ImgListComponent } from "./histories/img-list/img-list.component";
import { StatisticsComponent } from "./statistics/statistics.component";
import { BgStationComponent } from './statistics/bg-station/bg-station.component';
import { BgViolationComponent } from './statistics/bg-violation/bg-violation.component';

@NgModule({
  declarations: [
    LoginComponent,
    HomeComponent,
    CriminalRecordsAdminComponent,
    GetOutOfLineDetailsComponent,
    OilUnloadingProcessComponent,
    OilUnloadingProcessListComponent,
    ChangePasswordComponent,
    DisposeequipmentComponent,
    HistoriesComponent,
    ImgListComponent,
    StatisticsComponent,
    BgStationComponent,
    BgViolationComponent,
  ],

  imports: [
    PagesRoutingModule,
    CommonModule,
    A11yModule,
    PortalModule,
    ScrollingModule,
    CdkStepperModule,
    CdkTableModule,
    CdkTreeModule,
    DragDropModule,
    FormsModule,
    ReactiveFormsModule,
    RouterModule,
    NzFormModule,
    NzInputModule,
    UiModule,
    NzButtonModule,
    NzSelectModule,
    NzDatePickerModule,
    NzIconModule,
    NzGridModule,
    NzModalModule,
    NzPaginationModule,
    NzDropDownModule,
    NzMessageModule,
    NzSpinModule,
    NzTreeModule,
    NzTreeSelectModule,
    NzCollapseModule,
    NzStepsModule,
    NzTableModule,
    NzCheckboxModule,
    NzTimePickerModule,
    NzProgressModule,
    NzNotificationModule,
    NzPopconfirmModule,
    NzBadgeModule,
    NzRadioModule,
  ],
  entryComponents: [
    GetOutOfLineDetailsComponent,
    OilUnloadingProcessComponent,
    ChangePasswordComponent,
    DisposeequipmentComponent,
    ImgListComponent,
  ],
  schemas: [CUSTOM_ELEMENTS_SCHEMA],
})
export class PagesModule {}
