import { Component, OnInit, Output, EventEmitter } from '@angular/core';
import { HttpClient } from '@angular/common/http'
import { Router, ActivatedRoute } from '@angular/router'
import { CacheTokenService } from '../../service/cache-token.service' //引入服务
import { NzMessageService } from 'ng-zorro-antd/message';


@Component({
  selector: 'app-tabbar',
  templateUrl: './tabbar.component.html',
  styleUrls: ['./tabbar.component.scss']
})
export class TabbarComponent implements OnInit {

  constructor(private http: HttpClient, private router: Router, private route: ActivatedRoute, public token: CacheTokenService,
    private message: NzMessageService) { }
  surname: string
  userName: string
  isGasStation: string
  ngOnInit() {
    setInterval(() => {
      this.getTime()
    }, 1000);
    this.isGasStation = JSON.parse(sessionStorage.getItem('isGasStation'))
    if (this.isGasStation == 'true') {
      this.surname = JSON.parse(sessionStorage.getItem('userdataOfgasstation')).name
      this.userName = JSON.parse(sessionStorage.getItem('userdataOfgasstation')).userName
    } else {
      this.surname = JSON.parse(sessionStorage.getItem('userdata')).name
      this.userName = JSON.parse(sessionStorage.getItem('userdata')).userName
    }


  }

  //获得时间
  time: string
  getTime() {
    let myDate = new Date();
    let y = myDate.getFullYear();
    let M = myDate.getMonth() + 1;     //获取当前月份(0-11,0代表1月)
    let d = myDate.getDate();        //获取当前日(1-31)
    let h = myDate.getHours();       //获取当前小时数(0-23)
    let m = myDate.getMinutes();     //获取当前分钟数(0-59)
    let s = myDate.getSeconds();     //获取当前秒数(0-59)

    //检查是否小于10
    M = check(M);
    d = check(d);
    h = check(h);
    m = check(m);
    s = check(s);
    let timestr = y + "-" + M + "-" + d + "       " + h + ":" + m + ":" + s;
    this.time = timestr;
    //时间数字小于10，则在之前加个“0”补位。
    function check(i) {
      let num = (i < 10) ? ("0" + i) : i;
      return num;
    }
  }

  //退出系统
  signOut() {
    this.message.create('success', `退出成功`);
    this.token.delete()
    sessionStorage.clear()
    // window.localStorage.clear()

    localStorage.removeItem("isautologin")
    this.router.navigate(['/login'])
  }

  navChange(router) {
    this.router.navigate([router])
  }


  //修改密码
  changpsw() {
    // let dialogRef = this.dialog.open(ChangepasswordComponent, { width: '348.000051px' });
    // dialogRef.afterClosed().subscribe();
  }



}
