import { NgModule } from '@angular/core';
import { CommonModule } from '@angular/common';
import { UiRoutingModule } from './ui-routing.module';
import { A11yModule } from '@angular/cdk/a11y';
import { DragDropModule } from '@angular/cdk/drag-drop';
import { PortalModule } from '@angular/cdk/portal';
import { ScrollingModule } from '@angular/cdk/scrolling';
import { CdkStepperModule } from '@angular/cdk/stepper';
import { CdkTableModule } from '@angular/cdk/table';
import { CdkTreeModule } from '@angular/cdk/tree';
import { ReactiveFormsModule, FormsModule } from '@angular/forms';
import { IsnoPipe } from '../pipes/boolean.pipe';
import { TimePipe } from '../pipes/time.pipe';
import { TabbarComponent } from './tabbar/tabbar.component';

import { NzDropDownModule } from 'ng-zorro-antd/dropdown';
import { TitleComponent } from './title/title.component';
import { NzMessageModule } from 'ng-zorro-antd/message';
@NgModule({
  declarations: [TabbarComponent, IsnoPipe, TimePipe, TitleComponent],

  imports: [
    CommonModule,
    UiRoutingModule,
    A11yModule,
    CdkStepperModule,
    CdkTableModule,
    CdkTreeModule,
    DragDropModule,
    PortalModule,
    ScrollingModule,
    ReactiveFormsModule,
    FormsModule,
    NzDropDownModule,
    NzMessageModule
  ],

  exports: [TabbarComponent, TitleComponent]

})
export class UiModule { }
